# Changelog

## 2022-06-30
### Performance:
- 121 second run starting from step 0
- using map in deparrqueues
- total number of queues is 59650

Total queue length: 22390.0173427516274387 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
1479750 0 22282 0 26922 0 181100 (540181)
Together without default: 770485
(Explicitely) deleted queues: 40135

real	0m0.609s
user	0m0.601s
sys	0m0.008s


## 2022-05-24
### Fixed:
- step - 1 instead of step is now used for processing departures (queues one step) when processing tails
- when checking whether mixing emplace makes sense, condition  otherend >= newcapacity + 1 was changed to  otherend >= newcapacity - shift + 1 (sp almost full arrival queues are not ignored)

### Performance:
total number of queues is 705883
Total queue length: 976068.9286660669604316 m * sec  [probably difference is due to fixes, and float makes more sense]
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
23313216 0 357964 0 317316 0 2608143 (8465134)
Together without default: 11748557
(Explicitely) deleted queues: 625194

real	0m15.168s
user	0m15.034s
sys	0m0.132s

## 2022-05-20
### Performance:
total number of queues is 836021
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
31'057'977 0 425'627 0 238'515 0 3'363'932 (11'534'378)
Together without default: 15'562'452
(Explicitely) deleted queues: 1'022'416

real	0m20.571s
user	0m20.334s
sys	0m0.228s

total number of queues is 836021
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
31'248'549 0 425'627 0 238'515 0 3'363'932 (11'534'378)
Together without default: 15'562'452
(Explicitely) deleted queues: 1'022'416

real	0m22.338s
user	0m22.183s
sys	0m0.152s

### Fixed:
- wrong total queue length: 912712 instead of 923175! (unclear reason)


### Check for doesEmplaceMakesSense
- Asking queue:
total number of queues is 727433
Total queue length: 912712 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
63'761'667 0 336'900 0 225996 0 2'939'006 (15'159'831)
Together without default: 18'661'733
(Explicitely) deleted queues: 1'737'471

real	0m23.411s
user	0m23.264s
sys	0m0.144s

- Asking general doesEmplaceMakesSense
total number of queues is 727433
Total queue length: 912712 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
63761667 0 336900 0 225996 0 2939006 (15159831)
Together without default: 18661733
(Explicitely) deleted queues: 1737471

real	0m23.242s
user	0m23.075s
sys	0m0.164s


## 2022-05-19
### Performance after removing multiple vector creation for tails
total number of queues is 836021
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
41'499'606 0 425'627 0 238'515 0 3'363'932 (11'534'378)
Together without default: 15'562'452
(Explicitely) deleted queues: 1'022'416

real	0m20.325s
user	0m20.148s
sys	0m0.176s


### Performance with debug mode
total number of queues is 836474
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
37'132'062 0 3'708'679 0 18'333'414 0 6'648'730 (10'146'677)
Together without default: 38'837'500
Deleted queues: 2'875'648

real	0m29.042s
user	0m28.836s
sys	0m0.204s

### without debug mode (bugs fixed)
total number of queues is 836474
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
37132062 0 3708679 0 238608 0 6648730 (10146677)
Together without default: 20742694
Deleted queues: 2875648

real	0m21.696s
user	0m21.519s
sys	0m0.176s

### Fixed:
- untransitioned queues are also updated to (0,0) state if a split queue empties

### Changes:
- getLastDepartureProbability does not anymore runs through all departure moments until green_time if there are not many moments. 


## 2022-05-17
### Performance
- Total queue length: 923175 m * sec
- Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
- 37132062 0 3708679 0 238608 0 6648730 (10146677)
- Together without default: 20742694
- Deleted queues: 2875648
- real	0m21.140s
- user	0m21.002s
- sys	0m0.136s

### WAS:
total number of queues is 847017
Total queue length: 923175 m * sec
Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)):
37161780 0 3710324 0 245319 0 6647229 (10731581)
Together without default: 21334453
Deleted queues: 3443418

real	0m23.486s
user	0m23.217s
sys	0m0.248s



## 2022-02-01
### Changed
- Made transition\_flows a private variable to keep track of places where it is used.
- Default transitions are computed in Transitions and not in Queues.

### Added
- Added transitioned\_flows and transitioned\_full\_flows in an arrival state.

## 2022-01-31
### Bugs
- The reason for bug \# 28010 is found: since queue probabilities and arrival chain transitions are computed concurently, using just computed transitions leads to incorrect state probabilities.
- Proposed solution: keep track of transitioned probabilities. Then use altered transition probabilities (without the transitioned part).

## 2022-01-28
### Bugs 
- Bug \# 28010 found: under lamb = 0.15, min\_lamb=0.1, cycle = 70, green = 20, small\_green = 12, offset = 10, the downstream queue should be unstable, but it shows a stable behaviour.

### Fixed
- In getZeroProbabilities, a\_ind was changed to getAKey(a\_ind). This was making PLA useless.

### Changed
- Capacity, arrival and departure moments are updated to the case of acceleration = 2.6 m/s^2.

## 2022-01-27
### Performance after changes
-Queue constructors (default, simple, normal, mixes, copies, departures, assignments (emplaces)): 279897 0 6856 0 6102 0 32047 (96180)
-Together without default: 141185
-real	0m0.147s

### Changed
-In emplace function of ABPMap, assignment was changed to emplace.
-Averages of horizontal queue instead of backward queue are written to the file.

### Added
-Multiple Queue::emplace functions that just do the same as the corresponding constructor, without creating new queue.
-getNormalAverages function in Lane and Queues clases, which returns real average horizontal queues (in vehicles)



## 2022-01-25 [YANKED]
### Performance after changes
- real 0m0.3s

### Changed
-ABPMaps were added everywhere where possible
-Char changed to int everywhere

## 2022-01-18
### Performance after changes
-Queue constructors (default, simple, normal, mixes, copies, multiplied copies, assignments):
279897 14579 10722 74205 6102 0 128227
-Together: 385505
-real	0m0.153s


### Changed
- updateQueuesOneStep returns only DepArrQueues, not a pair (it means an extra copy)
- Instead of getMiddlePart, a constructor and prior check of whether the resulting queue will be empty are used.
- afterDeparture doesn't change the queue anymore, thus no copy is required
- The queue after departure is constructed explicitely from the original queue. The queue is constructed only if it is not apriori empty.
- No subqueues when updating the queues.
- Empty queues are often deleted.

## 2022-01-17
### Performance before changes
- 0.5s
- Simple run is now using #queue constructors (default, simple, normal, copies, multiplied copies, assignments): 833677 673 1023154 1254915 0 770240
- together 3112419 constructions

### Changed
- ArrQueues now use ABPMap instead of std::map<char, Queue>.
- Tails are emplaced back instead of pushed (no additional copy constructors).
- Queues are emplaced into DepArrQueues. Only one assignment is used to put them into the array of ABPMap.
- MixQueues functions were changed to constructors.

### Added
- Class ABPMap that is a wrapper over a std::array<type, 3>, where type = Queue is only now used.
- DepArrQueues methods addQueues and removeDownstreamParts.
- ArrQueues method hasKey(int). Here int is the index used in ABPMap (index = 0, 1, 2).

## 2022-01-15
### Fixed
- The bug with total untransitioned queue probability was fixed. The reason was the incorrect behaviour of removeMiddlePart of Queue class. 
- In multiple places pass by value was changed to pass by reference.

## 2022-01-14
### Bugs
- Total untransitioned queue probability is not equal to 1 for some choices of parameters.

### Fixed
- Queues::getJustEmptiedProbabilities is now based not on whether there was a departure second last second, but whether it was a departure second for a particular d_key.
- Queue::setProbability previously led to queues with start = 0 and some big end for an almost empty queue.

### Added
- `DepartureChain::setFirstProbability`  
 finds p^d<sub>+</sub> for d\_key in the beginning of a green period or at step 0.
- `DepartureChain::updateStateProbability`  
computes p^d<sub>+</sub> for d\_key that just started at current step.
- `DepartureChain::wasDepartureSecond(int second, Pair d_key)`  
returns true if second was a departure second for the default previous state for d\_key.
- Checks in updateQueuesOneStep and updateDepartures of whether the total probability changed in the right way.
- Check of the total untransitioned probability.
