# ISMIRT

This package can be used to predict the distribution of the queues in a traffic network. 

The input for the package contains several files that defind the arrival rates, turning probabilities and initial state of the system.

The output consists of the total queue length throught predicion horizon, i.e., sum of average queues for each lane for each second. It is also possible to output the distributions or other performance metrics.

## Usage

In the 'build' folder, run in terminal:

1. make

2. ./main


## Funding

This package is part of the "Implementing Stochastic Models for Intersections with Regulated Traffic" project funded by NWO.

## License

Copyright 2022 Anna Oblakova

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

